<?php
/**
* @version $Id: admin.juice.html.php,v 1.11 2005/08/08 12:21:09 Exp $
* @package JUICE
* @subpackage JUICE
* @copyright (C) 2000 - 2005 Pronique Software
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
* JUICE is Free Software
*/

/** ensure this file is being included by a parent file */
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

/**
* @package JUICE
*/
class HTML_users {

function showDeleted($delcount) {
?>
<h4><?=$delcount?> Registered Users Deleted.</h4>
<?
}
	function showAbout() {
?>
<table width="100%"><tr><td align=left>
<img src="http://www.pronique.com/embeddedimgs/proniquelogo.jpg">
</td></tr>
<tr><td><H2>JUICE</H2></td></tr>
<tr><td><H3>Joomla! User Import ComponEnt - fork for CB</H3></td></tr>
<tr><td><H4>Version: 1.0</H4></td></tr>
<tr><td><H4>Homepage: <a href="http://www.pronique.com">http://www.pronique.com</a></H4></td></tr>
<tr><td><b>This is a forked version of the original component to support community builder with listtab and extended selects plugin. Some of the description below might not be valid anymore.</b></td></tr>
<tr><td>
JUICE is an component for Joomla! that allows a site administrator to import users from a CSV text file.  This version of JUICE accepts all valid CSV files 
<br><br>Here are some of the features of JUICE 1.0 - fork for CB<br><br>

<b>Configurable Delimiter Character</b><br>
If your source application does not support comma delimited files you may choose the delimiter character at the time of import. Use 'TAB' for tab delimited files<br><br>

<b>Replace Entire User Database</b><br>
If you manage your user database in another application besides Joomla! you may find this feature useful.  If selected, just before import all users with the status Registered users are purged from the database.  This will will help reduce orphaned users.<br><br>

<b>Proper handling of Joomla! ACLs</b><br>
Importing and Deleting users from Mambo requires an application not only to deal with the users table but also the various ACL permissions tables of Mambo.  M3Port will make all of the proper table changes that are required.  If you have tried other import scripts you know that this is important to the integrity of your database and website.<br><br>

<b>Fills in gaps</b><br>
You can specify one of the colums as id. If a user exists that has same value in the id field as the csv file, the data of the user will be replace with data of the csv file.<br><br>


<b>Support Internationalizations of Selects if extended selects plugin is installed<b><br><br>

<b>Can import normalized data using multiple tables if listtab plugin is installed<b><br><br>

See instructions <a href="components/com_juice/instructions.pdf" target="blank">

</td></tr>
</table>
<?
	} # end function showAbout
	function showCSVImport( $option) {
		global $mosConfig_offset;
		?>
		<form action="index2.php" method="post" enctype="multipart/form-data" name="adminForm">

		<H2>Joomla! User Import ComponEnt (JUICE)</H2>

		<H5>Make sure you submit a properly formatted CSV file of users to import</H5>
		<table>
                <tr>
                    <td valign="top" align="right" width="30%">Delimiter:</td>
                    <td>
                        <input class="inputbox" type="text" name="delimiter" value="," size="3" maxlength="3">  Enter the uppercase word 'TAB' for tab delimited files.
                    </td>
		</tr>
		<tr>
                    <td valign="top" align="right" width="30%">Field titles on first line:</td>
                    <td>
                        <input class="inputbox" type="checkbox" name="shift1st" value="1" checked> Check this box if the first line of your CSV file contains something other than a user.
                    </td>
		</tr><tr>
                    <td valign="top" align="right" width="30%">File to import:</td>
                    <td>
                        <input class="inputbox" type="file" name="csvusers" value="" size="40" maxlength="250">
                    </td>
                </tr>
		</table>


		<input type="hidden" name="option" value="<?php echo $option;?>" />
		<input type="hidden" name="boxchecked" value="0" />
		<input type="hidden" name="hidemainmenu" value="0" />
		<input type="hidden" name="task" value="importcsv" />
		</form>
		<?php

	}


	function getModifyTableNameFunction(){
?>

	<script type="text/javascript">


function modifyTableName(select){

	var value=select.options[select.selectedIndex].value;	
	var options=getOptions(value);
	
	var selects = document.getElementsByName('fieldselect');

	for(i=0;i<selects.length;i++) {
		replaceOptions(selects[i],options);
	}

}

function getOptions(value){

	var options=null;
//Default user table
	if(value=='comprofiler'){
		options=new Array(new Option('New Field','',true)<?php echo HTML_users::getOptionsHTMLForTabid(null);?>);
	}
<?php
	foreach(getListTabs() as $listtab){
	
	?>
//List Tab
	else if(value=='<?php echo $listtab->tabid;?>'){
		options=new Array(new Option('New Field','',true)<?php echo HTML_users::getOptionsHTMLForTabid($listtab->tabid);?>);
	}
<?php
	}
?>
//New listtab table
	else{
		options=new Array(new Option('New Field','',true));	
	}
	return options;
}
function replaceOptions(select,options){
	
	for(var i=0;select.options.length>0;++i){
		select.options[0]=null;
	}
	for(var i=0;options.length>i;++i){
		select.options[i]=new Option(options[i].text,options[i].value);
	}


}
	</script>

<?php
	}
	function getOptionsHTMLForTabid($tabid){
		$ret="";
		foreach(getFieldsInTab($tabid) as $field){
			$ret.=",new Option('$field->title','$field->name')";
		}
		return $ret;	
	}


	function getModifyHeaderFunction(){
?>

	<script type="text/javascript">

  function prep4SQL(o){
	if(o.value!='') {
		o.value=o.value.replace('cb_','');
    		o.value='cb_' + o.value.replace(/[^a-zA-Z]+/g,'');
	}
  }

function modifyHeader(value,number){

	var inputs=null;

//Default new value
	if(value==''){
		inputs=new Array('','','');
	}
<?php
	foreach(getFieldsInTab(null) as $field){
	
	?>
	else if(value==<?php echo $field->fieldid;?>){
		inputs=new Array('<?php echo $field->title;?>','<?php echo $field->name;?>','<?php echo $field->title;?>','<?php echo $field->type;?>');
	}
<?php
	}
?>
	else{
		inputs=new Array(value,value,'');
	}

	document.getElementsByName('title'+number)[0].value=inputs[0];
	document.getElementsByName('name'+number)[0].value=inputs[1];
	document.getElementsByName('fieldtype'+number)[0].value=inputs[2];

<?php

/*	if(value==''){
		document.getElementsByName('title'+number)[0].disabled=false;
		document.getElementsByName('name'+number)[0].disabled=false;
		document.getElementsByName('fieldtype'+number)[0].disabled=false;
	}		
	else{
		document.getElementsByName('title'+number)[0].disabled=true;
		document.getElementsByName('name'+number)[0].disabled=true;
		document.getElementsByName('fieldtype'+number)[0].disabled=true;
	}*/		
?>
}
	</script>

<?php

	}
	function getIdentityChangedFunction(){

?>

	<script type="text/javascript">


function identityChanged(number){
	if(document.getElementById('tableselect').selectedIndex!=0){
		modifyTableName(document.getElementById('tableselect'));

		var options=getOptions('comprofiler');
	
		replaceOptions(document.getElementById('fieldselect'+number),options);

		
	}
}
	</script>

<?php

	}

	function showCSVContent($option,$task,$userarr,$delimiter,$headerrow){
		global $mosConfig_offset;
		?>
		<form action="index2.php" method="post" enctype="multipart/form-data" name="adminForm">

		<H2>Joomla! User Import ComponEnt (JUICE)</H2>

		<H5>Assign imported CVS to columns</H5>
		<table>
		<?php
		if(listTabInstalled()){
		?>
                <tr>
                    <td valign="top" align="right" width="30%">Import as:</td>
                    <td>
                        <select name="tableselect" id="tableselect" onchange="modifyTableName(this)">
				<option value="comprofiler" selected>Users</option>
				<?php
				foreach(getListTabs() as $listtab){
				?>
					<option value="<?php echo $listtab->tabid;?>">ListTab: <?php echo $listtab->title;?></option>
				<?php
				}
				?>
				<option value="">New ListTab</option> 
			</select>                
			<input class="inputbox" type="hidden" name="table_name" value="comprofiler" size="20" maxlength="255"> 
	
                    </td>
		</tr>
		<?php
		}
		?>
          
		<tr>
                    <td valign="top" align="right" width="30%">Delete existing users</td>
                    <td>
                        <input class="inputbox" type="checkbox" name="deleteexisting" value="1">
                    </td>
		</tr>
		<tr>
                    <td valign="top" align="right" width="30%">Run CB plugins</td>
                    <td>
                        <input class="inputbox" type="checkbox" name="plugins" value="1">
                    </td>
		</tr>
		<tr>
                    <td valign="top" align="right" width="30%">Email new users</td>
                    <td>
                        <input class="inputbox" type="checkbox" name="email" value="1">
                    </td>
		</tr>
		<tr>
                    <td valign="top" align="right" width="30%">Approve all new users</td>
                    <td>
                        <input class="inputbox" type="checkbox" name="approved" value="1">
                    </td>
		</tr>
		<tr>
                    <td valign="top" align="right" width="30%">Confirm all new users</td>
                    <td>
                        <input class="inputbox" type="checkbox" name="confirmed" value="1">
                    </td>
		</tr>

		</table>

		<table border="1"><tr>
		<?php
		#Get headers
		
		$eachuser=$userarr[0];

		$eachuser = str_replace ("\n", '', $eachuser);
		$eachuser = str_replace ("\s", '', $eachuser);
		$eachuser = str_replace ("\r", '', $eachuser);
		$fields=split($delimiter, $eachuser);
		
		$colNum=0;
		$cbFields=getCBFields();

		foreach($fields as $title){
			if(!$_REQUEST['shift1st']==1){
				$title="";
			}
			else
				$title=stripQuotes($title);
			HTML_users::getHeader($title,$cbFields,$colNum);
			++$colNum;	
		}			
		?>
		</tr>

		<?php
		#show data rows

		if($_REQUEST['shift1st']==1)
			array_shift($userarr);

		$row=0;
		foreach($userarr as $eachuser){
			$col=0;
			$eachuser = str_replace ("\n", '', $eachuser);
			$eachuser = str_replace ("\s", '', $eachuser);
			$eachuser = str_replace ("\r", '', $eachuser);
			$fields=split($delimiter, $eachuser);
			echo "<tr>\n";
			foreach($fields as $field){
				echo "<td>$field<input type=hidden name=\"data$row-$col\" value=$field></td>\n";
				$col++;
			}
			$row++;
			echo "</tr>\n";
		}


		?>
		</table>
		<input type="hidden" name="rows" value="<?php echo $row;?>" />
		<input type="hidden" name="cols" value="<?php echo $col;?>" />
		<input type="hidden" name="option" value="<?php echo $option;?>" />
		<input type="hidden" name="boxchecked" value="0" />
		<input type="hidden" name="hidemainmenu" value="0" />
		<input type="hidden" name="task" value="import" />
		<?php
		if(!listTabInstalled()){
			
		?>
		<input type="hidden" name="table_name" value="comprofiler" />
		<?php
		}
		?>
		</form>
		<?php
		HTML_users::getModifyHeaderFunction();
		HTML_users::getModifyTableNameFunction();
		if(listTabInstalled())
			HTML_users::getIdentityChangedFunction();
			
	
	}
	function getHeader($title,$cbFields,$colNum){
		?>
		<th><select name="fieldselect" id="fieldselect<?php echo $colNum?>" onchange="modifyHeader(this.options[this.selectedIndex].value,<?php echo $colNum;?>)">
		<option value="" selected>New Field</option>
		<option value="password">password, clear text</option>
		<option value="passmword_md5">password, md5</option>
		<?php
		foreach ($cbFields as $field){
			?><option value="<?php echo $field->fieldid;?>"><?php echo $field->title;?></option><?php
		}
		?></select><br>
		name<input name="name<?php echo $colNum;?>" value="<?php echo $title;?>" onchange="prep4SQL(this);"><br>
		title<input name="title<?php echo $colNum;?>" value="<?php echo $title;?>"><br>
		cb fieldtype<select name="fieldtype<?php echo $colNum;?>">
		<option value="checkbox">Check Box (Single)</option>
		<option value="multicheckbox">Check Box (Multiple)</option>
		<option value="date">Date</option>
		<option value="select">Drop Down (Single Select)</option>
		<option value="multiselect">Drop Down (Multi-Select)</option>
		<option value="emailaddress">Email Address</option>
		<option value="editorta">Editor Text Area</option>
		<option value="textarea">Text Area</option>
		<option value="text" selected>Text Field</option>
		<option value="radio">Radio Button</option>
		<option value="webaddress">Web Address</option>		
		</select>
		<br>identity<input type="radio" name="identity" value="<?php echo $colNum;?>" <?php if(listTabInstalled()) echo 'onclick="identityChanged('.$colNum.');"'?>>
		</th>
	<?php
	}

}
