<?php
/**
* @version $Id: admin.juice.php,v 1.11 2005/08/08 12:21:09 kochp Exp $
* @package JUICE
* @subpackage JUICE
* @copyright (C) 2000 - 2005 Pronique Software
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
* M3Port is Free Software
*/

/** ensure this file is being included by a parent file */
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

if (!$acl->acl_check( 'administration', 'manage', 'users', $my->usertype, 'components', 'com_users' )) {
	mosRedirect( 'index2.php', _NOT_AUTH );
}

require_once( $mainframe->getPath( 'admin_html' ) );
include_once($mosConfig_absolute_path."/administrator/components/com_comprofiler/ue_config.php" );
include_once($mosConfig_absolute_path."/administrator/components/com_comprofiler/plugin.class.php");
include_once($mosConfig_absolute_path."/administrator/components/com_comprofiler/comprofiler.class.php");
include_once($mosConfig_absolute_path."/administrator/components/com_comprofiler/imgToolbox.class.php");

#if (file_exists($mosConfig_absolute_path.'/administrator/components/com_juice/languages/'.$mosConfig_lang.'.php')) {
# include($mosConfig_absolute_path.'/administrator/components/com_juice/languages/'.$mosConfig_lang.'.php');
# } else {
#   include($mosConfig_absolute_path.'/administrator/components/com_juice/languages/english.php');
# }

$task 	= trim( mosGetParam( $_REQUEST, 'task', null ) );
#echo "Task:$task";
$cid 	= mosGetParam( $_REQUEST, 'cid', array( 0 ) );
if (!is_array( $cid )) {
	$cid = array ( 0 );
}

switch ($task) {
	case 'importcsv':
		importCSV($option, $task);
		break;
	case 'import':
		importUsers($option, $task);
		break;
	case 'deleteusers':
		$delcount = deleteregusers();
		HTML_users::showDeleted($delcount);
		break;
	case 'about';
		HTML_users::showAbout($option);
		break;
	case 'save':
	case 'apply':
 		saveUser( $option, $task );
		break;
	
	default:
		showCSVImport( $option);
		break;
}


function showCSVImport($option) {
	global $database, $mainframe, $my, $acl, $mosConfig_list_limit;

	HTML_users::showCSVImport($option);
}

function importCSV($option, $task){

global $_REQUESTS,$HTTP_POST_FILES;
global $database, $my;
global $mosConfig_live_site, $mosConfig_mailfrom, $mosConfig_fromname, $mosConfig_sitename;

	if ($_REQUEST['delimiter'] == 'TAB') {
		$delimiter = "\t";
	} else {
		$delimiter = $_REQUEST['delimiter'];
	}

#	echo "Delimiter is $delimiter<br>";
#	echo "<pre>" . print_r($_REQUEST) . "</pre>";
#	echo "<pre>" . print_r($_FILES) . "</pre>";
#	echo "<pre>NAME:" . $_FILES['csvusers']['name'] . "</pre>";
#	echo "<pre>TMP_NAME:" . $_FILES['csvusers']['tmp_name'] . "</pre>";
	$userarr = file($_FILES['csvusers']['tmp_name']);
#	print_r($userarr);
#	array_pop($userarr);

	HTML_users::showCSVContent($option,$task,$userarr,$delimiter,$_REQUEST['shift1st']);

}

function importUsers($option, $task) {

global $_REQUESTS;
global $database, $my;
global $mosConfig_live_site, $mosConfig_mailfrom, $mosConfig_fromname, $mosConfig_sitename;
global $_POST,$ueConfig,$_PLUGINS,$mosConfig_emailpass;

	echo "<p>Starting to import</p>";
	#OK, if importer wants to delete all existing registered users we should do it now.
	if ($_REQUEST['deleteexisting'] == 1) {deleteregusers();}

	//Prepare any new fields that can be found

	echo "<p>Preparing DB structure</p>";
	prepareDatabase();
	echo "<p>DB structure updated</p>";

	$limit=$_REQUEST['rows'];
	$a=0;
	echo "<p>Starting to loop through $limit rows</p>";
	for ($i=0;$i<$limit;++$i) {
		echo "<p>Processing datarow $i</p>";
		
		changePostValues($i,$_POST['cols']);
		$row = new mosUser( $database );
		if (!$row->bind($_POST)) {
			echo "<script type=\"text/javascript\"> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}
		
		$isNew = !$row->id;
		$pwd = '';
		
		echo "<p>Bind complete</p>";

		if ($isNew) {
		// new user stuff
		
			echo "<p>Creating new user</p>";
			if ($row->password == '') {
				$pwd = mosMakePassword();
				$row->password = md5( $pwd );
			} else {
				$pwd = $row->password;
				$row->password = md5( $row->password );
			}
			$row->registerDate = date("Y-m-d H:i:s");
		} else {
		// existing user stuff
			if ($row->password == '') {
			// password set to null if empty
				$row->password = null;
			} else {
				$row->password = md5( $row->password );
			}
		}

		//Override if md5 exists already
		if($row->password_md5){
			$row->password = $row->password_md5;
			$row->password_md5=null;
		}
			
		$query = "SELECT name"
		. "\n FROM #__core_acl_aro_groups"
		. "\n WHERE group_id = $row->gid"
		;
		$database->setQuery( $query );
		$usertype = $database->loadResult();
		$row->usertype = $usertype;

		//only parse name if it does not exist
		if(!$row->name||$row->name==''){

			SWITCH ($ueConfig['name_style']) {
				case 2: 	
					$row->name = cbGetUnEscaped(((isset($_POST['firstname'])) ? $_POST['firstname'] : "") . ' '
					   . ((isset($_POST['lastname']))  ? $_POST['lastname']  : ""));
				break;
				case 3:
				$row->name = cbGetUnEscaped(((isset($_POST['firstname'])) ? $_POST['firstname'] : "") . ' '
						   . ((isset($_POST['middlename']))  ? ($_POST['middlename'] . ' ')  : "")
						   . ((isset($_POST['lastname']))  ? $_POST['lastname']  : ""));
				break;
			}
			echo "<p>Parsed name: ".$row->name."</p>";

		}
		mosMakeHtmlSafe($row);
		if (!$row->check()) {
			echo "<script type=\"text/javascript\"> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}

		echo "<p>Start fields</p>";

		$sqlFormat = "Y-m-d";
		$selFields = '';
		$database->setQuery( "SELECT f.* FROM #__comprofiler_fields f, #__comprofiler_tabs t"
		. "\n WHERE f.published=1 and f.tabid = t.tabid AND t.enabled=1" );
		$rowFields = $database->loadObjectList();

		$cbFields=new cbFields();
		$rowExtras = new moscomprofiler($database);
		for($j=0, $n=count( $rowFields ); $j < $n; $j++) {
			$field=cbGetEscaped($rowFields[$j]->name);
			$value=null;
			if(isset($_POST[$rowFields[$j]->name])) $value=$cbFields->prepareFieldDataSave($rowFields[$j]->type,$rowFields[$j]->name,$_POST[$rowFields[$j]->name]);
			$rowExtras->$field=$value;
		}

		$rowExtras->id=$row->id;
		$rowExtras->user_id=$row->id;
		$rowExtras->firstname=cbGetUnEscaped((isset($_POST['firstname']) ? $_POST['firstname'] : ""));
		$rowExtras->middlename=cbGetUnEscaped((isset($_POST['middlename']) ? $_POST['middlename'] : ""));
		$rowExtras->lastname=cbGetUnEscaped((isset($_POST['lastname']) ? $_POST['lastname'] : ""));
		$rowExtras->approved=cbGetUnEscaped($_POST['approved']);
		$rowExtras->confirmed=cbGetUnEscaped($_POST['confirmed']);
		
		echo "<p>Fields processed</p>";
	
		$_PLUGINS->loadPluginGroup('user');

		$newCBuser = (isset($_POST['newCBuser'])) ? ($_POST['newCBuser']=="1") : true;
	
		// save user params
		$params = mosGetParam( $_POST, 'cbparams', null );
		//echo "params:".print_r($params);
		if($params != null) {
			if (is_array( $params )) {
				$txt = array();
				foreach ( $params as $k=>$v) {
					$txt[] = "$k=$v";
				}
				$row->params = implode( "\n", $txt );
			}
		}

		if($isNew || $newCBuser) {
			if($_POST['plugins']==1)
				$_PLUGINS->trigger( 'onBeforeNewUser', array(&$row,&$rowExtras, false));
			if($_PLUGINS->is_errors()) {
				echo "<script type=\"text/javascript\">alert(\"".$_PLUGINS->getErrorMSG()."\"); window.history.go(-1); </script>\n";
				exit();
			}

			if (!$row->store()) {
				// echo "<script type=\"text/javascript\"> alert('".$row->getError()."'); window.history.go(-2); </script>\n";
				echo $row->getError();
				exit();
			}
			echo "<p>User saved</p>";

			$database->setQuery("SELECT id FROM #__users WHERE username = '".cbGetEscaped($_POST['username'])."'");
			$uid = $database->loadResult();
			$row->id = $uid;
			$rowExtras->id = $uid;
			$rowExtras->user_id = $uid;
			if(!$database->insertObject( '#__comprofiler', $rowExtras)) {		// escapes
				// echo "<script type=\"text/javascript\"> alert('store:".$database->stderr(true)."'); window.history.go(-2); </script>\n";
				echo $database->stderr(true);
				exit();
			}
		
			$tabs = new cbTabs( 0, 2);
			$tabs->savePluginTabs($row, $rowExtras, $_POST);

			if($_POST['plugins']==1)
				$_PLUGINS->trigger( 'onAfterNewUser', array($row, $rowExtras, false, true));
			if($rowExtras->approved && $rowExtras->confirmed) activateUser($row, false, false);

		} else {
		
			$uid = $row->id;
			// get previous state for triggering the activation event:
			$database->setQuery( "SELECT * FROM #__comprofiler c, #__users u WHERE c.id=u.id AND c.id='".$uid."'");
			$previousState = $database->loadObjectList();
			if (count($previousState)>0) {
				$previousState = $previousState[0];
			}
		
			$rowExtras->id = $uid;
			$rowExtras->user_id = $uid;
	
			if($_POST['plugins']==1)
				$_PLUGINS->trigger( 'onBeforeUpdateUser', array(&$row,&$rowExtras));

			if($_PLUGINS->is_errors()) {
				echo "<script type=\"text/javascript\">alert(\"".$_PLUGINS->getErrorMSG()."\"); window.history.go(-1); </script>\n";
				exit();
			}

			if (!$row->store()) {
				// echo "<script type=\"text/javascript\"> alert('".$row->getError()."'); window.history.go(-2); </script>\n";
				echo $row->getError();
				exit();
			}
			echo "<p>User updated</p>";

			if(!$database->updateObject( '#__comprofiler', $rowExtras,'id', false)) {	// escapes
				// echo "<script type=\"text/javascript\"> alert('store:".$database->stderr(true)."'); window.history.go(-2); </script>\n";
				echo $database->stderr(true);
				exit();
			}
		
			$tabs = new cbTabs( 0, 2);
			$tabs->savePluginTabs($row, $rowExtras, $_POST);
	
			if($_POST['plugins']==1)
				$_PLUGINS->trigger( 'onAfterUpdateUser', array($row, $rowExtras, true));

			if (!($previousState->approved && $previousState->confirmed) && ($rowExtras->approved && $rowExtras->confirmed)) {
				activateUser($row, false);
			}
		}
	

	// update the ACL

		if ($isNew) {
		} else {
			$database->setQuery( "SELECT aro_id FROM #__core_acl_aro WHERE value='$row->id'" );
			$aro_id = $database->loadResult();

			$database->setQuery( "UPDATE #__core_acl_groups_aro_map"
			. "\nSET group_id = '$row->gid'"
			. "\nWHERE aro_id = '$aro_id'"
			);
			$database->query() or die( $database->stderr() );
		}

		$row->checkin();
		if ($isNew) {
		
			$query = "SELECT * FROM #__comprofiler c, #__users u WHERE c.id=u.id AND c.id =" . $uid;
			$database->setQuery($query);
			$user = $database->loadObjectList();
			$user[0]->password=$pwd;			// set password in cleartext for email to new users

			//set this to 1 to force password to be sent to new users.
			$mosConfig_emailpass=1;

			$cbNotification = new cbNotification();
			if($_POST['email']==1) $cbNotification->sendFromSystem($user[0],getLangDefinition($ueConfig['reg_welcome_sub']),getLangDefinition($ueConfig['reg_welcome_msg']));
	
		}
		echo "i=$i, limit=$limit";
		$a++;
	}

	echo "<H3>$a rows of data imported!</H3>";

}

function deleteregusers() {
global $database, $my;
global $mosConfig_live_site, $mosConfig_mailfrom, $mosConfig_fromname, $mosConfig_sitename;
        $query = "SELECT id FROM #__users where `gid`=18";
        $database->setQuery( $query );
	$rows = $database->loadObjectList();

	foreach ($rows as $row) {
		$delcount++;
		$query .= "DELETE FROM #__core_acl_aro where `value`=" . $row->id;
		$database->setQuery( $query );
        	$database->query();
	}

	$query = "DELETE FROM #__core_acl_groups_aro_map where `group_id`=18";
        $database->setQuery( $query );
       	$database->query();

	$query = "DELETE FROM #__users where `gid`=18";
	$database->setQuery( $query );
        $database->query();
	return $delcount;
}


function listTabInstalled(){
	return 1;
}

function getCBFields(){

	global $database;

	$query = "SELECT DISTINCT f.* FROM #__comprofiler_fields f, #__comprofiler_tabs t WHERE (f.tabid=t.tabid and t.pluginclass <> 'listtab') or f.tabid is null";
	$database->setQuery( $query );
        $database->query();
		
	return $database->loadObjectList();
}

function getListTabs(){

	global $database;

	$query = "SELECT DISTINCT tabid, title FROM #__comprofiler_tabs WHERE pluginclass = 'listtab'";
	$database->setQuery( $query );
        $database->query();
		
	return $database->loadObjectList();
		
}
function getFieldsInTab($tabid){

	global $database;

	$query = "SELECT DISTINCT name, title, type, fieldid FROM #__comprofiler_fields";
	if($tabid != null)
		$query.=" WHERE tabid = $tabid";
	$database->setQuery( $query );
        $database->query();
		
	return $database->loadObjectList();
		
}
function stripQuotes($string){
	if(substr($string,0,1)=='"')
		$string=substr($string,1,-1);
	return $string;
}

function changePostValues($i,$cols){
	global $database, $_POST;

	echo "<p>POST content<br><pre>";
	print_r($_POST);
	echo "</pre></p>";

	for($a=0;$a<$cols;++$a){
		
		echo "<p>getting POST value: ".'data'.$i.'-'.$a."</p>";
		echo "<p>getting POST value: ".'name'.$a."</p>";

		$value=$_POST['data'.$i.'-'.$a];
		$name=$_POST['name'.$a];
		//If we do import to a table other than comprofiler
		if($_POST['tableselect']!='comprofiler'&&$a!=$_POST['identity']){
			$name='new1'.$name;
		}
		
		$_POST[$name]=$value;
		echo "<p>set POST value $name=$value, confirm:".$_POST[$name]."</p>";
	}
		
	//Get ID
	$ide=$_POST['identity'];
	$idfield=$_POST['name'.$ide];

	$query = "SELECT id FROM #__comprofiler where ".$idfield."='".$_POST['data'.$i.'-'.$ide]."'";
	$database->setQuery( $query );
	$_POST['id']=$database->loadResult();
}

function prepareDatabase(){
	
	global $database, $my, $_POST;
	global $mosConfig_live_site, $mosConfig_mailfrom, $mosConfig_fromname, $mosConfig_sitename;

	//check if fields exist
	$tabid=0;
	
	$table=$_POST['tableselect'];
	
	if($table==''){
		$query ="select id from #__comprofiler_plugins where element='listtab'";
		$database->setQuery( $query );
	        $database->query();
		$query = "insert into #__comprofiler_tabs (title, pluginclass,pluginid) values('untitled listtab','listtab',".$database->loadResult().")'";
		$database->setQuery( $query );
	        $database->query();
		$tabid=$database->loadResult();	
		
		$sql="CREATE TABLE IF NOT EXISTS `#__comprofiler_listtab_".$tabid.
			"` (`id` INT NOT NULL AUTO_INCREMENT ,`userid` INT NOT NULL ,".
			"`tabid` INT NOT NULL ,PRIMARY KEY ( `id` )) TYPE = MYISAM ;";
		$database->SetQuery($sql);

		if (!$database->query()) {
			echo "<script type=\"text/javascript\"> alert('store:".
				$database->stderr(true)."'); window.history.go(-1);</script>\n";
		}	
			
	}
	else if($table=='comprofiler')
		$table="#__comprofiler";
	else{
		$tabid=$table;
		$table="#__comprofiler_listtab_".$table;
	}

//Check fields

	$limit=$_POST['cols'];

	for($i=0;$i<$limit;++$i){
		$name=$_POST['name'.$i];
		$query = "select * from #__comprofiler_fields where name='".$name."'";
		$database->setQuery( $query );
	        $database->query();

		if($database->getNumRows()==0){
			//create new field
			$title=$_POST['name'.$i];
			$type=$_POST['type'.$i];
			$sql="insert into #__comprofiler_fields (name,table,title,type) values('$name','#__comprofiler','$title','$type')";
			$database->setQuery( $query );
		        $database->query();
			
			switch($type) {
					CASE 'date':
						$cType='DATE';
					break;
					CASE 'editorta':
					CASE 'textarea':
					CASE 'multiselect':
					CASE 'multicheckbox':
						$cType='MEDIUMTEXT';
					break;	
					CASE 'checkbox':
						$cType='TINYINT';
					break;			
					default:
						$cType='VARCHAR(255)';
					break;

				
			}
			$sql="ALTER TABLE `$table` ADD `$name` $cType";
			$database->SetQuery($sql);
			$database->LoadResult();
		}
	}	
	
}

?>
